; htm2clip by A.Ruzanov
; 03.07.2009

#NoTrayIcon

$MOK = "Setup has finished installing htm2clip on your computer"
If @OSLang = 0419 Then
	$MP = "    Opera"
	$MMenu = '"Копировать текст с форматированием"'
Else
	$MP = "Select a Opera folder in the list below, then click OK."
	$MMenu = '"Copy text with formatting"'
EndIf

$StartDir = @ScriptDir
If Not FileExists($StartDir & "\opera.exe") Then
	$StartDirArr = StringSplit(StringLower(RegRead("HKEY_CURRENT_USER\Software\Opera Software", "Last CommandLine v2")), "\opera.exe ", 1)
	If IsArray($StartDirArr) Then $StartDir = $StartDirArr[1]
EndIf
If Not FileExists($StartDir & "\opera.exe") Then $StartDir = RegRead("HKEY_CURRENT_USER\Software\Opera Software", "Last Directory3")
If Not FileExists($StartDir & "\opera.exe") Then $StartDir = ""

$OperaDir = FileSelectFolder($MP, "", 0, $StartDir)
If @error Then Exit

$ver = StringSplit(FileGetVersion($OperaDir & "\Opera.dll"), ".")
$Version = $ver[1] & "." & $ver[2]
$isOpera10 = $ver[1] >= 10 And $ver[3] >= 1413

If $isOpera10 Then
	$o6Defini = $OperaDir & "\operaprefs_default.ini"
	$o6ini = "operaprefs.ini"
	$defFolder = $OperaDir & "\ui"
Else
	$o6Defini = $OperaDir & "\OperaDef6.ini"
	$o6ini = "opera6.ini"
	$defFolder = $OperaDir & "\defaults"
EndIf

If IniRead($o6Defini, "System", "Multi User", "1") = 1 Then
	$VarOpDir = StringSplit($OperaDir, "\")
	$NameDir = $VarOpDir[UBound($VarOpDir) - 1]
	$OperaProfileDir = @AppDataDir & "\opera\" & $NameDir
	If Not $isOpera10 Then $OperaProfileDir = $OperaProfileDir & "\profile"
Else
	$OperaProfileDir = $OperaDir & "\profile"
EndIf

$VarMenu = $OperaProfileDir & "\menu\"
$VarOpera6 = $OperaProfileDir & "\" & $o6ini
$MenuPath = IniRead($VarOpera6, "User Prefs", "Menu Configuration", "")

FileInstall("htm2clip.exe", $OperaDir & "\program\htm2clip.exe", 1)

IniWrite($VarOpera6, "File Types Section Info", 'Version', '2')
IniWrite($VarOpera6, "File Types", 'text/cwf', '3,' & $OperaDir & '\program\htm2clip.exe,,,,|')
IniWrite($VarOpera6, "File Types Extension", 'text/cwf', ',0')

$VarDefMenu = $defFolder & "\standard_menu.ini"

$VarSearchM = FileFindFirstFile($VarMenu & "*.ini")
If $VarSearchM = -1 Or $MenuPath = $VarDefMenu Then
	$VarOperaMenu = $VarDefMenu
	Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
Else
	While 1
		$VarOperaMenu = $VarMenu & FileFindNextFile($VarSearchM)
		If @error Then ExitLoop
		Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
	WEnd
	FileClose($VarSearchM)
EndIf

MsgBox(64, "htm2clip setup", $MOK, 10)
Exit

Func Transfer($Home)
	$VarBTM = IniReadSection($VarOperaMenu, $Home)
	If @error Then
		$VarHNDL = FileOpen($VarOperaMenu, 1)
		$VarDefHNDL = FileOpen($VarDefMenu, 0)
		$BTM = ""
		While $BTM <> "[" & $Home & "]"
			$BTM = FileReadLine($VarDefHNDL)
		WEnd
		
		$BTM = @CRLF & $BTM
		
		Do
			FileWriteLine($VarHNDL, $BTM)
			$BTM = FileReadLine($VarDefHNDL)
		Until StringLeft($BTM, 1) = "[" Or StringLeft($BTM, 2) = ";["
		FileClose($VarHNDL)
		FileClose($VarDefHNDL)
	EndIf
EndFunc   ;==>Transfer

Func Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
	$VarBak = $VarOperaMenu & "_1.bak"
	If FileExists($VarBak) Then
		$Num = 2
		While FileExists($VarOperaMenu & "_" & $Num & ".bak")
			$Num = $Num + 1
		WEnd
		$VarBak = $VarOperaMenu & "_" & $Num & ".bak"
	EndIf
	
	FileCopy($VarOperaMenu, $VarBak, 1)
	
	Transfer("Hotclick Popup Menu")
	
	IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, "Copy text with formatting"')
	IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, "Копировать текст с форматированием"')
	IniWrite($VarOperaMenu, "Hotclick Popup Menu", '--------------------', '')
	IniWrite($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, ' & $MMenu, '"Go to Page, "javascript:(function(){var encodeBase64=function(a){var b='''';var c=0;var i=0;var d='''';var e=a.length;var f=[];var g=''ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'';while(c=a.charCodeAt(i++)){if(c<0x80){f[f.length]=c}else if(c<0x800){f[f.length]=0xc0|(c>>6);f[f.length]=0x80|(c&0x3f)}else if(c<0x10000){f[f.length]=0xe0|(c>>12);f[f.length]=0x80|((c>>6)&0x3f);f[f.length]=0x80|(c&0x3f)}else{f[f.length]=0xf0|(c>>18);f[f.length]=0x80|((c>>12)&0x3f);f[f.length]=0x80|((c>>6)&0x3f);f[f.length]=0x80|(c&0x3f)}if(i==e){while(f.length%%3){f[f.length]=0;d+=''=''}}if(f.length>2){b+=g[f[0]>>2];b+=g[((f.shift()&3)<<4)|(f[0]>>4)];b+=g[((f.shift()&0xf)<<2)|(f[0]>>6)];b+=g[f.shift()&0x3f]}}return(b+d)};var selWin=function(w){if(w.getSelection()!='''')return w;for(var i=0,f,r;f=w.frames[i];i++){try{if(r=arguments.callee(f))return r}catch(e){}}};var win=selWin(window);if(win){var doc=win.document;var link=win.location.href;if(win.location.protocol==''file:'')link=link.replace(''localhost'','''');var sel=doc.createDocumentFragment();var range=win.getSelection().getRangeAt(0);sel.appendChild(doc.createComment(''StartFragment''));sel.appendChild(range.cloneContents());sel.appendChild(doc.createComment(''EndFragment''));var ele=range.commonAncestorContainer;while(ele){if(ele.nodeType==1){var clone=ele.cloneNode(false);clone.appendChild(sel);sel=clone};ele=ele.parentNode};var h=sel.insertBefore(doc.createElement(''head''),sel.firstChild);var title=doc.getElementsByTagName(''title'')[0];if(title)h.appendChild(title.cloneNode(true));var meta=doc.createElement(''meta'');meta.httpEquiv=''content-type'';meta.content=''text/html; charset=utf-8'';h.appendChild(meta);var base=doc.getElementsByTagName(''base'')[0];var b=base?base.cloneNode(false):doc.createElement(''base'');if(!b.href)b.href=link;h.appendChild(b);var styles=doc.styleSheets;for(var i=0,si;si=styles[i];i++){var style=doc.createElement(''style'');style.type=''text/css'';if(si.media.mediaText)style.media=si.media.mediaText;try{for(var j=0,rule;rule=si.cssRules[j];j++){style.appendChild(doc.createTextNode(rule.cssText+''\n''))}}catch(e){if(si.ownerNode)style=si.ownerNode.cloneNode(false)};h.appendChild(style)};var all=sel.getElementsByTagName(''*'');for(var i=all.length;i--;){var el=all[i];switch(el.nodeName.toLowerCase()){case''frame'':case''iframe'':case''embed'':case''img'':el.src=el.src;break;case''link'':case''area'':case''a'':el.href=el.href;break;case''script'':el.parentNode.removeChild(el);break}};var doctype='''';var dt=doc.doctype;if(dt&&dt.name){doctype+=''<!DOCTYPE ''+dt.name;if(dt.publicId)doctype+='' PUBLIC \x22''+dt.publicId+''\x22'';if(dt.systemId)doctype+='' \x22''+dt.systemId+''\x22'';doctype+=''>\n''};var f=doc.createElement(''iframe'');f.width=0;f.height=0;f.frameBorder=''no'';f.scrolling=''no'';f.src=''data:text/cwf;charset=UTF-8;base64,''+encodeBase64(''SourceURL:''+link+''\r\n\r\n''+doctype+sel.outerHTML);doc.documentElement.appendChild(f);f.parentNode.removeChild(f)}})();",,,"Copy" "')
	
EndFunc   ;==>Correct
